function tran = firingorderbig(node_tree, ...
  idparentran,forward,backward,mark,idnode)
  // fungsi ini menentukan urutan pemfirean transisi
  // node_tree dan idparent diperoleh dari buildtree
  // idparent merupakan vektor baris dan idnode adalah
  // indeks node yang mengcover mark

  // inisialisasi
  tran = [];

  // memfilter node ke root
  idpath = idnode;
  while idparentran(1,idpath(1)) ~= 0
    idpath = [idparentran(1,idpath(1)) idpath];
  end
  node_tree = node_tree(:,idpath);
  idnode = length(idpath);

  // idparentran hanya memuat transisi, parent dihapus
  idparentran = idparentran(2,idpath);

  // mencari place yang unbounded
  idunbounded = find(node_tree(:,idnode) == %inf);

  // jika place bounded maka langsung ditemukan
  if idunbounded == []
    tran = idparentran;
    return;
  end
  // variabel node_tree memuat keadaan yang diperlukan
  // idparentran adalah vektor baris berisi transisi

  // mencari indeks omega yang pertama kali
  idomega = zeros(idunbounded);
  for i = 1:length(idunbounded)
    idomega(i) = find( ...
      node_tree(idunbounded(i),:) == %inf,1);
  end
  idomegaunik = unique(idomega);

  // menyimpan jumlah omega yang berbeda dan
  // jumlah node pada path
  nomegaunik = length(idomegaunik);
  npath = length(idparentran);
  n = length(mark);

  // pemfirean terbalik
  idfire = idparentran(idomegaunik(nomegaunik)+1:npath);
  mark = mark - sum(forward(:,idfire),'c') + ...
    sum(backward(:,idfire),'c');
  tran = [idfire tran];
  // perulangan utama
  for i = nomegaunik:-1:2
    // memfire transisi sebelumnya
    // keadaan sebelum => node_tree(:,idomegaunik(i)-1)
    // transisi yg difire => idomegaunik(i)
    st_awal = node_tree(:,idomegaunik(i)-1) + ...
      forward(:,idparentran(idomegaunik(i))) - ...
      backward(:,idparentran(idomegaunik(i)));
    // dibandingkan dengan mark
    idplace = find(st_awal ~= mark);
    // mencari node yang didominasi
    idnode = vectorfind(bool2s(ones( ...
      1,idomegaunik(i)-idomegaunik(i-1)).*. ...
      st_awal >= node_tree(:,idomegaunik(i-1): ...
      idomegaunik(i)-1)),ones(n,1),'c');
    idnode = vectorfind(bool2s(ones( ...
      1,length(idnode)).*.st_awal(idplace) > ...
      node_tree(idplace,idomegaunik(i-1)-1+idnode)), ...
      ones(idplace,1),'c');
    idnode = idomegaunik(i-1) - 1 + idnode;
    // menentukan jumlah perulangan
    selisih = st_awal(idplace) - ...
      node_tree(idplace,idnode);
    jmliterasi = max(0,max(ceil((mark(idplace) - ...
      st_awal(idplace))./(selisih))));
    // pemfirean sebanyak jmliterasi
    mark(idplace) = mark(idplace) - jmliterasi*selisih;
    tran = [ones(1,jmliterasi).*.idparentran( ...
      idnode+1:idomegaunik(i)) tran];
    // pemfirean terbalik
    idfire = idparentran(idomegaunik(i-1)+1: ...
      idomegaunik(i));
    mark = mark - sum(forward(:,idfire),'c') + ...
      sum(backward(:,idfire),'c');
    tran = [idfire tran];
  end
  // memfire transisi sebelumnya
  st_awal = node_tree(:,idomegaunik(1)-1) + ...
    forward(:,idparentran(idomegaunik(1))) - ...
    backward(:,idparentran(idomegaunik(1)));
  // dibandingkan dengan mark
  idplace = find(st_awal ~= mark);
  // mencari node yang didominasi
  idnode = vectorfind(bool2s(ones( ...
    1,idomegaunik(1)-1).*.st_awal >= ...
    node_tree(:,1:idomegaunik(i)-1)),ones(n,1),'c')
  idnode = vectorfind(bool2s(ones( ...
    1,length(idnode)).*.st_awal(idplace) > ...
    node_tree(idplace,idnode)),ones(idplace,1),'c');
  // menentukan jumlah perulangan
  selisih = st_awal(idplace) - ...
    node_tree(idplace,idnode);
  jmliterasi = max(0,max(ceil((mark(idplace) - ...
    st_awal(idplace))./selisih)));
  // pemfirean sebanyak jmliterasi
  mark(idplace) = mark(idplace) - jmliterasi*selisih;
  tran = [ones(1,jmliterasi).*.idparentran( ...
    idnode+1:idomegaunik(1)) tran];
  // pemfirean terbalik
  idfire = idparentran(2:idomegaunik(1));
  mark = mark - sum(forward(:,idfire),'c') + ...
    sum(backward(:,idfire),'c');
  tran = [idfire tran];
endfunction
