function Z = maxplusdelay(x,d,T,A)

// Z = maxplusdelay(x,d,T,A), maxplus algebra propagation of delays
// x: the real departure such that x >= d
// d: vector of initial timetable
// T: scalar, that is timetable period


mode(0);

ieee(1);

Z = [];
y = x - d;
while norm(y,1) > 0
   Z = [Z y];
   d = d + T;
   x = maxplusoplus(maxplusotimes(A,x),d);
   y = x - d;
end
Z = [Z y];


endfunction
