function [lam,vx,sigma,q] = maxplusmaxalgolgeneral(A,x0)

// [lam,vx] = maxplusmaxalgol(A), Biono algorithm to compute eigenvalue &
// eigenvector of a square matrix in max-plus algebra.
// syntax [lam,vx] = maxplusmaxalgol(A), where lam and vx are an eigenvalue and
// a corresponding eigenvector, respectively of matrix A
//
// See also 
// maxalgolpa, maxalgolepa
// 
// Max-Plus Algebra Toolbox, ver. 1.0 Dec, 2008
// Copyright (C) Subiono, Dec, 2008

tes=max(A','r');
        cari=find(tes==-%inf);
        if cari~=[] then
            error('There is row in matrix A don t have finite element');
            return;
        end

lam = [];
vx = [];

// Display mode
mode(0);

// Display warning for floating point exception
ieee(1);

n = size(A,1);


B=maxpluszeros(n,n);
c=find(A~=-%inf);
B(c)=zeros(length(c));

//x = round(100*rand(n,1,"normal"));
x=x0;
//x = zeros(n,1);

//x=sum(A,2)/n;
//tempA=maxpluspwrbig(A,n);
//x=maxplusotimes(tempA,x);

// eigenvalue

for ulang=1:2
    if ulang==1
        Xall = x;
        x = maxplusotimes(A,x);
        s=2;
        qhasil=[];
        while qhasil==[]
            s=s+1;
           Xall = [Xall x];
           x = maxplusotimes(A,x);
           Xselisih = ones(1,size(Xall,2)).*.x-Xall;
           Bx=maxplusotimes(B,Xselisih);
           sama=Bx-Xselisih;
           q = find(clean(max(sama,'r'))==0 & clean(min(sama,'r'))==0);
           //tempq=[tempq,q];
           sigma2=s-q;
           for i=1:length(q)
               if modulo(sigma2(i),2)==0
                   del=Xselisih(:,q(i))-2*Xselisih(:,q(i)+(sigma2(i)/2));
                   if clean(max(del,'r'))==0 & clean(min(del,'r'))==0
                        qhasil=q(i);
                        sigma2=sigma2(i);
                        break;
                   end
               end
           end
        end
        q=qhasil;
        //eigenvalue
        lam = Xselisih(:,q)./sigma2;
        p=q+sigma2/2;
        d=sigma2/2;
        //sigma is one
        if  d==1
            vx=Xall(:,q+1);
            q1=q;
            d1=d;
            q=1;
            d=1;
            break;
        end
        vx = max([lam*(p-q-1:-1:0)] + Xall(:,q:p-1),'c');
        //tempvx=vx;
        //power algorithm 
        if clean(max(lam)-min(lam))==0
            q1=q;
            d1=d;
            q=1;
            d=1;
            break;
         end
         //generalized power algorithm
            q1=q;
            d1=d;
            x=vx;
            vx=[];

    else
    //generalized power algorithm step
        q=1;
        d=1;
        x1 = maxplusotimes(A,x);
        x2 = maxplusotimes(A,x1);
        Xselisih=[x2,x2]-[x,x1];
        del=Xselisih(:,1)-2*Xselisih(:,2);
        if clean(max(del,'r'))==0 & clean(min(del,'r'))==0 //isequal(Xselisih(:,1),2*Xselisih(:,2))
            del=lam-Xselisih(:,2);
            if clean(max(del,'r'))==0 & clean(min(del,'r'))==0
                vx=x1;
                q=1;
                d=1;
                break;
            end
        end
        
        while vx==[]
            q=q+1;
            x=x1;
            x1 = x2;
            x2 = maxplusotimes(A,x1);
            Xselisih=[x2,x2]-[x,x1];
            del=Xselisih(:,1)-2*Xselisih(:,2);
            if clean(max(del,'r'))==0 & clean(min(del,'r'))==0//isequal(Xselisih(:,1),2*Xselisih(:,2))
                Bx=maxplusotimes(B,Xselisih(:,1));
                if clean(max(del,'r'))==0 & clean(min(del,'r'))==0//isequal(lam,Xselisih(:,2))
                    vx=x2;
                    d=1;
                    break;
                end
            end
            
        end
            
    end
end
d=[q1-1,d1,q-1,d];
sigma=d1;
q=q1-1;





endfunction
