function Z = minpluseye(a,b)

// Z = minpluseye(a,b), max-plus algebra identity matrix
// Similar with usual identity matrix but element 0 replaced with -%inf
// and element 1 replaced with 0
//
// See also 
// otimes, oplus, aplus, maxplusscg, maxcircuit, maxalgol, maxalgolpa, maxalgolepa, iseigvec


mode(0);

ieee(1);

if a <= 0 | b <= 0
   error('minpluseye: input must be positive integers');
end

Z = zeros(a,b);
Z(:) = +%inf;
Z(1:a+1:a*min(a,b)) = 0;


endfunction
