function X = minplusotimes(A,B) 

// X = otimes(A,B), mainplus algebra multiplication with appropriate size.
// If A is scalar then X = A + B.
// If A and B are matrices then only finite A(i,j) and B(i,j) interested to 
// be calculated
// If A is matrix then this function multiply each row of A with B
//
// See also 
// oplus, aplus, maxpluspwr, maxplusscg, maxcircuit, maxalgol, maxalgolpa, maxalgolepa, iseigvec


// Display mode
mode(0);

// Display warning for floating point exception
ieee(1);

// Syntax X = minplusotimes(A,B).
na = size(A);
nb = size(B);

// Output variables initialisation (not found in input variables)
X = minpluszeros(na(1),nb(2));

if na(1) + na(2) == 2 | nb(1) + nb(2) == 2
   X = A + B;
   return;
end

if  na(2) ~= nb(1)
   error("minplusotimes: The column size of first matrix and ...
      row size of second matrix must be equal");
end

A = A';
for i = 1:na(1)
   X(i,:) = min(B+ones(1,nb(2)).*.A(:,i),'r');
end


endfunction
