function [pos,id_pos,pos_node,right_tree] = ...
  treeposition(pos,id_pos,left,dist,id_node, ...
  id_parent_tran,level)
  // fungsi ini merupakan rekursif
  // berguna untuk menghitung posisi tiap node
  // id_pos menyatakan id node
  // pos matriks dengan dua baris
  // baris 1 => posisi x dan baris 2 => posisi y
  // jumlah kolom pos = jumlah elemen id_pos

  // right_tree : batas kanan tree
  // right_ch : anak terkanan
  // left_ch : anak terkiri
  // pos_child : posisi anak kemudian (baru)
  // pos_node : posisi node ini (output)

  // inisialisasi
  right_tree = left;
  pos_child = left;
  left_ch = left;
  // mencari child
  id_ch = find(id_parent_tran(1,:) == id_node);

  // jika mempunyai child
  if id_ch ~= []
    [pos,id_pos,left_ch,right_tree] = ...
      treeposition(pos,id_pos,pos_child, ...
      dist,id_ch(1),id_parent_tran,level + 1);
  end

  // inisialisasi variabel right_ch
  right_ch = left_ch;

  // menghitung posisi child
  for i = 2:length(id_ch)
    pos_child = right_tree + dist;
    [pos,id_pos,right_ch,right_tree] = ...
      treeposition(pos,id_pos,pos_child, ...
      dist,id_ch(i),id_parent_tran,level + 1);
  end

  // hitung posisi node ini
  pos_node = round((left_ch + right_ch)/2);

  // update variabel posisi
  new_pos = [pos_node;level];
  pos = [pos new_pos];
  id_pos = [id_pos id_node];
endfunction
